package summarizer;

import java.util.ArrayList;
import java.util.List;

public class NodePair {

	private Node source;
	private Node target;

	public NodePair(Node source, Node target) {
		this.source = source;
		this.target = target;
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((source == null) ? 0 : source.hashCode());
		result = prime * result + ((target == null) ? 0 : target.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}
		if (obj == null) {
			return false;
		}
		if (getClass() != obj.getClass()) {
			return false;
		}
		NodePair other = (NodePair) obj;
		if (source == null) {
			if (other.source != null) {
				return false;
			}
		} else if (!source.equals(other.source)) {
			return false;
		}
		if (target == null) {
			if (other.target != null) {
				return false;
			}
		} else if (!target.equals(other.target)) {
			return false;
		}
		return true;
	}

	public Node getSource() {
		return source;
	}

	public void setSource(Node source) {
		this.source = source;
	}

	public Node getTarget() {
		return target;
	}

	public void setTarget(Node target) {
		this.target = target;
	}

	public static List<NodePair> get2x2Combinations(NodePair np,
			List<NodePair> nps, List<Node> nodes, int i, int total) {
		List<Node> list = new ArrayList<Node>(nodes);
		if (nps.size() == total) {
			return nps;
		} else {
			if (np == null) {
				for (int z = 0; z < nodes.size(); z++) {
					np = new NodePair(nodes.get(z), null);
					list.remove(0);
					nps = get2x2Combinations(np, nps, list, z, total);
				}
			} else {
				np.setTarget(list.get(0));
				nps.add(np);
				list.remove(0);
				if (list.size() == 0) {
					return nps;
				} else {
					NodePair np2 = new NodePair(np.getSource(), null);
					nps = get2x2Combinations(np2, nps, list, i, total);
				}
			}

		}
		return nps;
	}

	@Override
	public String toString() {
		return source.toString() + " -> " + target.toString();
	}

}
