package summarizer;

import java.util.HashMap;
import java.util.Map;
import java.util.Set;

public class OntologyData {

	private Map<String, Integer> frequencies;

	public OntologyData() {
		this.frequencies = new HashMap<String, Integer>();
	}

	public Map<String, Integer> getFrequencies() {
		return frequencies;
	}

	public void setFrequencies(Map<String, Integer> frequencies) {
		this.frequencies = frequencies;
	}

	public void addFrequency(String nodeLabel, int freq) {
		this.frequencies.put(nodeLabel.toLowerCase(), freq);
	}

	public int getFrequency(String nodeLabel) {
		if (this.frequencies.get(nodeLabel.toLowerCase()) == null) {
			return 0;
		} else {
			return this.frequencies.get(nodeLabel.toLowerCase());
		}
	}

	public int getHigherFrequency() {
		int freq = 0;
		Set<String> keys = this.frequencies.keySet();
		for (String key : keys) {
			int tempFreq = this.frequencies.get(key);
			if (freq <= tempFreq) {
				freq = tempFreq;
			}
		}
		return freq;
	}

	@Override
	public String toString() {
		return this.frequencies.toString();
	}

}
