package summarizer;

public class Triple {

	private String sourceConcept;
	private String name;
	private String targetConcept;

	public Triple(String sourceConcept, String name, String targetConcept) {
		super();
		if (sourceConcept != null) {
			this.sourceConcept = sourceConcept;
		} else {
			this.sourceConcept = "";
		}
		this.name = name;
		if (targetConcept != null) {
			this.targetConcept = targetConcept;
		} else {
			this.targetConcept = "";
		}
	}

	public String getSourceConcept() {
		return sourceConcept;
	}

	public void setSourceConcept(String sourceConcept) {
		this.sourceConcept = sourceConcept;
	}

	public String getName() {
		return name;
	}

	public void setName(String name) {
		this.name = name;
	}

	public String getTargetConcept() {
		return targetConcept;
	}

	public void setTargetConcept(String targetConcept) {
		this.targetConcept = targetConcept;
	}

	@Override
	public String toString() {
		return "(" + this.sourceConcept + ", " + this.name + ", "
				+ this.targetConcept + ")";
	}

	@Override
	public int hashCode() {
		final int prime = 31;
		int result = 1;
		result = prime * result + ((name == null) ? 0 : name.hashCode());
		result = prime * result
				+ ((sourceConcept == null) ? 0 : sourceConcept.hashCode());
		result = prime * result
				+ ((targetConcept == null) ? 0 : targetConcept.hashCode());
		return result;
	}

	@Override
	public boolean equals(Object obj) {
		if (this == obj) {
			return true;
		}
		if (obj == null) {
			return false;
		}
		if (getClass() != obj.getClass()) {
			return false;
		}
		Triple other = (Triple) obj;
		if (name == null) {
			if (other.name != null) {
				return false;
			}
		} else if (!name.equals(other.name)) {
			return false;
		}
		if (sourceConcept == null) {
			if (other.sourceConcept != null) {
				return false;
			}
		} else if (!sourceConcept.equals(other.sourceConcept)) {
			return false;
		}
		if (targetConcept == null) {
			if (other.targetConcept != null) {
				return false;
			}
		} else if (!targetConcept.equals(other.targetConcept)) {
			return false;
		}
		return true;
	}

}
