package summarizer;

import java.util.ArrayList;
import java.util.List;

import junit.framework.TestCase;
import summarizer.Node;
import summarizer.NodePair;

public class NodePairTest extends TestCase {

	public NodePairTest(String name) {
		super(name);
	}

	@Override
	protected void setUp() throws Exception {
		super.setUp();
	}

	@Override
	protected void tearDown() throws Exception {
		super.tearDown();
	}

	public void testGet2x2Combinations() {
		List<Node> strs = new ArrayList<Node>();
		Node a = new Node(1, "a");
		strs.add(a);
		Node b = new Node(2, "b");
		strs.add(b);
		Node c = new Node(3, "c");
		strs.add(c);
		Node d = new Node(4, "d");
		strs.add(d);
		Node e = new Node(5, "e");
		strs.add(e);
		List<NodePair> nps = new ArrayList<NodePair>();
		nps = NodePair.get2x2Combinations(null, nps, strs, 0, strs.size()
				* (strs.size() - 1) / 2);
		assertEquals(strs.size() * (strs.size() - 1) / 2, nps.size());
		assertTrue(nps.contains(new NodePair(a, b)));
		assertTrue(nps.contains(new NodePair(a, c)));
		assertTrue(nps.contains(new NodePair(a, d)));
		assertTrue(nps.contains(new NodePair(a, e)));
		assertTrue(nps.contains(new NodePair(b, c)));
		assertTrue(nps.contains(new NodePair(b, d)));
		assertTrue(nps.contains(new NodePair(b, e)));
		assertTrue(nps.contains(new NodePair(c, d)));
		assertTrue(nps.contains(new NodePair(c, e)));
		assertTrue(nps.contains(new NodePair(d, e)));
	}
}
